package edu.gwu.jword;

import javax.swing.*;
import javax.swing.JTextField;
import javax.swing.tree.TreeCellRenderer;
import java.awt.event.*;
import javax.swing.tree.TreeCellEditor;
import javax.swing.event.*;

//modified textbox
public class JTextTreeRenderer extends JTextField implements TreeCellRenderer,
    MouseMotionListener, MouseListener{
    
    private javax.swing.event.EventListenerList modelListeners = new EventListenerList();
    /** Creates a new instance of JTextTreeRenderer */
    public JTextTreeRenderer() {
        this.setEditable(true);
        this.setBorder(null);
       this.addMouseMotionListener(this);
       this.addMouseListener(this);
    }
    
    public java.awt.Component getTreeCellRendererComponent(JTree tree, Object value, boolean selected, boolean expanded, boolean leaf, int row, boolean hasFocus) {
        this.setText(value.toString());
        return this;
    }
    
    public void mouseDragged(MouseEvent e) {
    }
    
    public void mouseMoved(MouseEvent e) {
        int startPos = this.viewToModel(e.getPoint());
        String curString = this.getText();
        //System.out.println(curString + " "  + startPos);
        //System.out.println(curString.charAt(startPos));
        //find a spacebar, or first character
        try
        {
            while (curString.charAt(startPos) != ' ' && startPos >= 0)
            {
                //short circuiting not supported in java
                if (--startPos == -1)
                    break;
            
            }
        
            //get to first letter of word
            startPos++;
       
            int len = curString.indexOf(' ', startPos);
        
            if (len == -1)
                len = curString.length();
            //System.out.println(startPos + " " + len);
            this.select(startPos, len);
            curString = curString.substring(startPos, len);
            //System.out.println("Click Count: " + e.getClickCount());
        
            if (e.getClickCount() == 1)
            {
                this.fireSingleClick(e.getX(), e.getY(), curString);
            }
            else if (e.getClickCount() == 2)
            {
                this.fireDoubleClick(e.getX(), e.getY(), curString);
            }
            
        }
        catch (Exception ex){}
    }
    
    public void addModelListener(modelListener l)
    {
       modelListeners.add(modelListener.class, l);   
    }
     
    public void removeModelListener(modelListener l)
    {
        modelListeners.remove(modelListener.class, l);   
    }
    
    public void fireSingleClick(int x, int y, String curWord)
    {
        //System.out.println("Fired Single Click");
        curWord = curWord.replaceAll("(\\\"|\\!|\\.|\\?|\\,|\\:|\\(|\\))", "");
        ModelEvent e = new ModelEvent(this, x, y, 1, curWord);
         Object[] listeners = modelListeners.getListenerList();

         // loop through each listener and pass on the event if needed
         int numListeners = listeners.length;
         for (int i = 0; i < numListeners; i++)
         {
            if (listeners[i]==modelListener.class) 
            {
               // pass the event to the listeners event dispatch method
                ((modelListener)listeners[i+1]).oneClick(e);
            }            
         }

    }
    
    public void fireDoubleClick(int x, int y, String curWord)
    {
        //System.out.println("Fired Double Click");
        curWord = curWord.replaceAll("(\\\"|\\!|\\.|\\?|\\,|\\:|\\(|\\))", "");
         ModelEvent e = new ModelEvent(this, x, y, 2, curWord);
         Object[] listeners = modelListeners.getListenerList();

         // loop through each listener and pass on the event if needed
         int numListeners = listeners.length;
         for (int i = 0; i < numListeners; i++)
         {
            if (listeners[i]==modelListener.class) 
            {
               // pass the event to the listeners event dispatch method
                ((modelListener)listeners[i+1]).twoClicks(e);
            }            
         }
        
    }
    
    public void mouseClicked(MouseEvent e) {
        //System.out.println("Clicked");
        mouseMoved(e);
    }    
 
    public void mouseEntered(MouseEvent e) {
    }    
    
    public void mouseExited(MouseEvent e) {
    }    
    
    public void mousePressed(MouseEvent e) {
    }    
    
    public void mouseReleased(MouseEvent e) {
    }
    
}




