package edu.gwu.jword;

import edu.gwu.jworddrivers.*;
import java.util.*;
import javax.swing.*;
import javax.swing.tree.*;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.event.*;
import java.awt.*;
import edu.gwu.util.*;
import java.awt.event.*;
import javax.swing.border.*;

/** This is the Example Class to learn how to use the WordNet library.  This example
 * project will show you how to query the Wordnet library to get results in a
 * Thesauraus fashion.
 */

public class JWord extends javax.swing.JFrame implements TreeSelectionListener
   , modelListener{



    public JWord()
    {
        try
        {
            UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        }
        catch(Exception e){}
        try
        {
          this.setExtendedState(this.getExtendedState() | this.MAXIMIZED_BOTH);
          jbInit();
          txtWord.grabFocus();

        }
        catch(Exception e) {
          e.printStackTrace();
        }



        //clear tree
        //add event handler for tree
        //treeDictionary.setCellRenderer(new JTextTreeRenderer());

        treeDictionary.setScrollsOnExpand(true);
        treeDictionary.setEditable(true);
        DefaultTreeCellRenderer dt = new DefaultTreeCellRenderer();

        ImageIcon node = new ImageIcon("icons/pages.gif");
        ImageIcon leaf = new ImageIcon("icons/paper.gif");
        dt.setLeafIcon(leaf);
        dt.setClosedIcon(node);
        dt.setOpenIcon(node);
        treeDictionary.setCellRenderer(dt);
        treeDictionary.setCellEditor(new MyTreeCellEditor(treeDictionary, dt, null, this, this));

        treeDictionary.setModel(new DefaultTreeModel(new DefaultMutableTreeNode("")));
        treeDictionary.getSelectionModel().setSelectionMode
            (TreeSelectionModel.SINGLE_TREE_SELECTION);
        treeDictionary.addTreeSelectionListener(this);

        loadDriverMenu();

    }

    private void loadDriverMenu()
    {
       java.util.Properties p = new Properties();
       try
       {
          java.io.FileInputStream f = new java.io.FileInputStream("drivers.props");
          p.load(f);
       }
       catch (Exception e)
       {
            System.out.println("Driver List could not be found");
            System.exit(0);
       }
       int nDrivers = Integer.parseInt(p.getProperty("numDrivers"));
       String drivers[] = new String[nDrivers];
       String drivernames[] = new String[nDrivers];
       for (int i = 0; i < nDrivers; i++)
       {
         drivers[i] = p.getProperty("driver." + i);
         drivernames[i] = p.getProperty("name."+i);
       }
    mnuDrivers = new JCheckBoxMenuItem[nDrivers];
    for (int i = 0; i < nDrivers; i++)
    {
      mnuDrivers[i] = new JCheckBoxMenuItem(drivernames[i]);
      mnuDrivers[i].addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        jSetDriver_itemStateChanged(e);
      }
      });
      mnuDrivers[i].setSelected(true);
      jMenu1.add(mnuDrivers[i]);
    }

    FileClassLoader cl = new FileClassLoader("../jworddrivers");

          driver = null;
          Class c = null;


          numDrivers = mnuDrivers.length;
          driver = new JWordDriver[numDrivers];

          try {
            for (int i = 0; i < numDrivers; i++)
            {
               c = cl.loadClass(drivers[i], true);
              try {
                driver[i] = (JWordDriver) c.newInstance();
              }
              catch (IllegalAccessException ex1) {
              }
              catch (InstantiationException ex1) {
              }
               driver[i].initDictionary();
            }
          }
          catch (ClassNotFoundException ex) {
            System.out.println(ex);
            System.exit(0);
          }




    }



    private void treeDictionaryMouseMoved(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_treeDictionaryMouseMoved
        TreePath tp = treeDictionary.getPathForLocation((int)evt.getPoint().getX(),  (int)evt.getPoint().getY());
        if (tp == null)
        {
            return;
        }
        //TreeNode cn = (TreeNode)tp.getLastPathComponent();
        try
        {
           // if (tp.getLastPathComponent().toString().endsWith("Matches"))
                //treeDictionary.expandPath(tp);

            treeDictionary.startEditingAtPath(tp);

            if (evt.getClickCount() == 1)
            {
                if (treeDictionary.isCollapsed(tp))
                    treeDictionary.expandPath(tp);
                else
                    treeDictionary.collapsePath(tp);
            }


        }
        catch(Exception e)
        {
        }
    }//GEN-LAST:event_treeDictionaryMouseMoved

    private void txtWordMouseMoved(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_txtWordMouseMoved
        /*
         Learn how to do some viewToModel commands
        //get current position
        int startPos = txtWord.viewToModel(evt.getPoint());
        String curString = txtWord.getText();
        System.out.println(curString + " "  + startPos);
        System.out.println(curString.charAt(startPos));
        //find a spacebar, or first character
        while (curString.charAt(startPos) != ' ' && startPos >= 0)
        {
            //short circuiting not supported in java
            if (--startPos == -1)
                break;

        }

        //get to first letter of word
        startPos++;



        int len = curString.indexOf(' ', startPos);

        if (len == -1)
            len = curString.length();
        System.out.println(startPos + " " + len);
        txtWord.select(startPos, len);*/

    }//GEN-LAST:event_txtWordMouseMoved

    //This method detects if ENTER was pressed and accelerates the
    //control to the FIND button
    private void txtWordKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_txtWordKeyPressed
        //accelerator key
        if (evt.getKeyCode() == evt.VK_ENTER)
        {
            btnSearchActionPerformed(null);
        }
    }//GEN-LAST:event_txtWordKeyPressed

    //Process Click Events on the JTree
    private void treeDictionaryMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_treeDictionaryMouseClicked
       DefaultMutableTreeNode node =
            (DefaultMutableTreeNode)treeDictionary.getLastSelectedPathComponent();

       /*if(evt.getClickCount() == 2)
       {
          if (node == null) return; //if we clicked nothing, exit

          //Figure out if I am a word, definition, or part of speech
          //--LEVEL 1 = ROOT
          //----LEVEL 2 = Part of Speech
          //------LEVEL 3 = Gloss
          //---------LEVEL 4 = Word <--Leaf

          Object nodeInfo = node.getUserObject();

          //Search the word double clicked
          if (node.isLeaf()) {
            txtWord.setText(nodeInfo.toString());
            btnSearchActionPerformed(null);
          }
       }
       else*/
       if (evt.getClickCount() == 1)
       {
         if (node.getPath() == null)
           return;

          TreePath tp = new TreePath(node.getPath());
          //TreePath tp = treeDictionary.getPathForLocation((int)evt.getPoint().getX(),  (int)evt.getPoint().getY());
          //TreeNode cn = (TreeNode)tp.getLastPathComponent();




              /*if (treeDictionary.isCollapsed(tp))
                  treeDictionary.expandPath(tp);
               else
                 treeDictionary.collapsePath(tp);*/


          if (node.getDepth() == 1) //is a desc
          {
              //Show the full gloss
              if (treeDictionary.isCollapsed(tp))
              {
                  txtEditorPane.setText(((JWordNode)node.getUserObject()).getCurrentDescription());
              }
              else
                 txtEditorPane.setText(((JWordNode)node.getUserObject()).getDescription());
              txtDescription.setRows(txtDescription.getLineCount());

              pnlSouth.setVisible(true);
              pnlOrient.doLayout();
          }
          else
          {
              //hide the gloss bar
              txtDescription.setText("");
              txtEditorPane.setText("");
              txtDescription.setRows(0);
              pnlSouth.setVisible(false);
              pnlOrient.doLayout();
          }
       }

    }//GEN-LAST:event_treeDictionaryMouseClicked


    public void btnSearchActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnSearchActionPerformed

        //Exit if there is nothing to search for
        if ((txtWord.getText()).equals(lastSearch) || txtWord.getText().equals(""))
           return;
         popupmen.addWord(txtWord.getText());

        lastSearch = new String(txtWord.getText());

        DefaultMutableTreeNode root = new DefaultMutableTreeNode("Root");
        DefaultMutableTreeNode[] dicNodes = new DefaultMutableTreeNode[numDrivers];

        for (int i = 0; i < numDrivers; i++)
        {
          if (mnuDrivers[i].isSelected())
           dicNodes[i] = new DefaultMutableTreeNode(driver[i].getTitle());
        }

        DefaultTreeModel tm = new DefaultTreeModel(root);
        for (int i = 0; i < numDrivers; i++)
        {
          if (!mnuDrivers[i].isSelected())
            continue;

           driver[i].returnSearch(dicNodes[i], lastSearch);
           if (!dicNodes[i].isLeaf())
           root.add(dicNodes[i]);
        }
        treeDictionary.setModel(tm);

        for (int i = 0; i < numDrivers; i++)
        {
          if (mnuDrivers[i].isSelected())
            treeDictionary.expandPath(new TreePath(dicNodes[i].getPath()) );
        }

    }//GEN-LAST:event_btnSearchActionPerformed


    /** Override this to catch JTree events */
    public void valueChanged(TreeSelectionEvent e) {
        /*
    DefaultMutableTreeNode node = (DefaultMutableTreeNode)
                       treeDictionary.getLastSelectedPathComponent();

    if (node == null) return;

    Object nodeInfo = node.getUserObject();
    if (node.isLeaf()) {
        txtWord.setText(nodeInfo.toString());

    } */
}

    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        System.exit(0);
    }//GEN-LAST:event_exitForm

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) throws IllegalAccessException,
      InstantiationException
    {
       /*dlgSelectDictionaries dlg = new dlgSelectDictionaries();
       dlg.setSize(500, 300);
       dlg.setLocation(200, 200);
       dlg.setVisible(true);

      FileClassLoader cl = new FileClassLoader("../jworddrivers");

      driver = null;
      Class c = null;

      String[] driverStr = dlg.getDictionaryClassStrings();
      numDrivers = driverStr.length;
      driver = new JWordDriver[numDrivers];

      try {
        for (int i = 0; i < numDrivers; i++)
        {
           c = cl.loadClass(driverStr[i], true);
           driver[i] = (JWordDriver) c.newInstance();
           driver[i].initDictionary();
        }
      }
      catch (ClassNotFoundException ex) {
        System.out.println(ex);
        System.exit(0);
      }*/
        new JWord().show();
        return;
    }

    public void oneClick(ModelEvent e)
    {
        //capture a single click for a highlighted word in the tree

        //forward event to treeHandler
        this.treeDictionaryMouseClicked(
            new MouseEvent((Component)e.getSource(), 0, 0, 0, e.getX(), e.getY(), 1, false ));
        //expand path
        //System.out.println("single" + e.getNumClicks() + " " + e.getWord());
    }

    public void twoClicks(ModelEvent e)
    {
        //look up selected word
        txtWord.setText(e.getWord());
        btnSearchActionPerformed(null);
        //System.out.println(e.getNumClicks() + " " + e.getWord() + "Performed Action");
        //replace path
    }


    private JWordDriver[] driver;
    private int numDrivers;
    //Stores last word searched for to prevent duplicate searching
    java.awt.Point pausePoint;
    private String lastSearch = new String("");
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnSearch;
    private javax.swing.JLabel lblEnterWord;
    private javax.swing.JPanel pnlCenter;
    private javax.swing.JPanel pnlNorth;

    private javax.swing.JScrollPane pnlSouth;
    private javax.swing.JScrollPane scrTree;
    private javax.swing.JTree treeDictionary;
    private javax.swing.JTextArea txtDescription;
    private javax.swing.JLabel txtEditorPane;
    public javax.swing.JTextField txtWord;
  JPanel pnlOrient = new JPanel();
  BorderLayout borderLayout1 = new BorderLayout();
  JMenuBar mnuMain = new JMenuBar();
  JMenu jMenu1 = new JMenu();
  JCheckBoxMenuItem[] mnuDrivers;
  JPanel jPanel1 = new JPanel();
  BorderLayout borderLayout2 = new BorderLayout();
  TitledBorder titledBorder1;
  TitledBorder titledBorder2;
  JButton btnBack = new JButton();


  private void jbInit() throws Exception {
    pnlOrient = new javax.swing.JPanel();
        pnlNorth = new javax.swing.JPanel();
        lblEnterWord = new javax.swing.JLabel();
        txtWord = new javax.swing.JTextField();
        btnSearch = new javax.swing.JButton();
        pnlCenter = new javax.swing.JPanel();
        scrTree = new javax.swing.JScrollPane();
        treeDictionary = new javax.swing.JTree();
        pnlSouth = new javax.swing.JScrollPane();
        txtDescription = new javax.swing.JTextArea();
        txtEditorPane = new javax.swing.JLabel();

        titledBorder1 = new TitledBorder("");
    titledBorder2 = new TitledBorder("");
    setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
    this.setFont(new java.awt.Font("Tahoma", 0, 16));
    this.setJMenuBar(mnuMain);
        setTitle("JWord 3.0");
        setName("JWord");
        setSize(700, 500);
    this.setState(Frame.MAXIMIZED_BOTH);
    this.setExtendedState(this.getExtendedState() | this.MAXIMIZED_BOTH);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });

        pnlOrient.setLayout(new java.awt.BorderLayout());

        pnlOrient.setMinimumSize(new java.awt.Dimension(700, 500));
        pnlNorth.setLayout(new java.awt.BorderLayout());

        lblEnterWord.setFont(new java.awt.Font("Tahoma", 1, 16));
    lblEnterWord.setText("Enter a Word:");
    jMenu1.setBackground(Color.lightGray);
    jMenu1.setToolTipText("");
    jMenu1.setText("Loaded Dictionaries");

    treeDictionary.setFont(new java.awt.Font("Tahoma", 0, 14));
    btnSearch.setFont(new java.awt.Font("Tahoma", 0, 16));

        txtWord.setFont(new java.awt.Font("Dialog", 3, 12));
        txtWord.setHorizontalAlignment(javax.swing.JTextField.LEFT);
        txtWord.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                txtWordKeyPressed(evt);
            }
        });
        txtWord.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
            public void mouseMoved(java.awt.event.MouseEvent evt) {
                txtWordMouseMoved(evt);
            }
        });

        jPanel1.setLayout(borderLayout2);

    btnBack.setFont(new java.awt.Font("Tahoma", 0, 16));
    btnBack.setText("Back");
    btnBack.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseClicked(MouseEvent e) {
        btnBack_mouseClicked(e);
      }
    });
    btnBack.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnBack_actionPerformed(e);
      }
    });
    pnlNorth.add(txtWord, java.awt.BorderLayout.CENTER);

        btnSearch.setText("Find");
        btnSearch.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnSearchActionPerformed(evt);
            }
        });

        pnlNorth.add(btnSearch, java.awt.BorderLayout.EAST);
    pnlNorth.add(jPanel1,  BorderLayout.WEST);
    jPanel1.add(lblEnterWord,  BorderLayout.WEST);
    jPanel1.add(btnBack, BorderLayout.EAST);

        pnlOrient.add(pnlNorth, java.awt.BorderLayout.NORTH);

        pnlCenter.setLayout(new java.awt.BorderLayout());

        treeDictionary.setEditable(true);
        treeDictionary.setRootVisible(false);
        treeDictionary.setAutoscrolls(true);
        treeDictionary.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                treeDictionaryMouseClicked(evt);
            }
        });
        treeDictionary.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
            public void mouseMoved(java.awt.event.MouseEvent evt) {
                treeDictionaryMouseMoved(evt);
            }
        });

        scrTree.setViewportView(treeDictionary);

        pnlCenter.add(scrTree, java.awt.BorderLayout.CENTER);

        pnlOrient.add(pnlCenter, java.awt.BorderLayout.CENTER);

        pnlSouth.setBackground(new java.awt.Color(255, 255, 204));
        txtDescription.setBackground(java.awt.SystemColor.info);
        txtDescription.setEditable(false);
        txtDescription.setBorder(new javax.swing.border.EtchedBorder());
        txtDescription.setDisabledTextColor(new java.awt.Color(0, 0, 0));
        txtDescription.setFocusable(false);
        txtDescription.setEnabled(false);
        pnlSouth.setViewportView(txtDescription);

        txtEditorPane.setBackground(new java.awt.Color(255, 255, 204));
        txtEditorPane.setOpaque(true);
        pnlSouth.setViewportView(txtEditorPane);

        pnlOrient.add(pnlSouth, java.awt.BorderLayout.SOUTH);

        getContentPane().add(pnlOrient, java.awt.BorderLayout.CENTER);
    mnuMain.add(jMenu1);


        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        //setBounds((screenSize.width-500)/2, (screenSize.height-400)/2, 500, 400);
        this.txtWord.transferFocus();
  }

  void jSetDriver_itemStateChanged(ItemEvent e) {

  }

  void btnBack_actionPerformed(ActionEvent e) {


  }

  void btnBack_mouseClicked(MouseEvent e) {
    popupmen.pop();
  }
 popUpLast5 popupmen = new popUpLast5(btnBack, this);
    // End of variables declaration//GEN-END:variables

}
