
package edu.gwu.jworddrivers;

/**
 *
 * @author  Kunal Johar
 * This is an abstract class that must be extended to support functionality
 * This class contains the information displayed onto the JWord console
 */
public abstract class JWordNode 
{
    /** Must Implement a real constructor.  Default constructor is provided to allow
     * inheritance.<BR>
     * In Driver implementation you must have some area of storage declared too hold
     * the word and a string to allow the three methods to work correctly
     */ 
    public JWordNode(){}
   
    
    /** Returns the description specific to the current node selected
     */
    abstract public String getCurrentDescription();
    
    /** Returns description for all nodes under this node.
     *  It is recommended to show example sentences or paragraphs of usage here
     */
    abstract public String getDescription();
    
      /** Return what the node should display<BR>
     * This is recommended to be a list of words or an example string
     * with the search word bolded and italicized
     */  
    abstract public String toString();
}
