package edu.gwu.jworddrivers;

import java.util.regex.*;
import java.util.*;
import java.io.*;
import java.nio.*;
import java.nio.charset.*;
import java.nio.channels.*;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.*;


public class RogetwithLemmaDriver extends RogetDriver
{
  WordNetDriver wd;
  public RogetwithLemmaDriver()
  {
    wd = new WordNetDriver();
    wd.initDictionary();

  }
  public String getTitle()
  {
    return "Roget's Thesaurus Using WordNet's Lemma Concept";

  }
  public void returnSearch(DefaultMutableTreeNode root, String word)
  {
    String newWord = wd.getLemma(word, JWordDriver.POS_NOUN);
    System.out.println(newWord);
    if (newWord == null)
     {
       return;
     }
     else if (newWord.equals(word))
       return;


    super.returnSearch(root, newWord);
  }
  public  void returnPOS(DefaultMutableTreeNode posRoot, int POS, String searchWord)
  {
        super.returnPOS(posRoot, POS, wd.getLemma(searchWord, POS));
  }
}
